def app
def tag
pipeline {
    options {
        disableConcurrentBuilds()
    }
    agent any
    stages {
        stage('Check') {
            steps {

                script {

                    switch (BRANCH_NAME) {
                        case "master":
                            tag = "prod"
                            break
                        case "test":
                            tag = "test"
                            break
                        case "dev":
                            tag = "dev"
                            break
                        default:
                            error("Error")
                            break
                    }

                    // check tools
                    BaseimageNamePhp = "nutellinoplayground/api-php"
                    BaseimageNameNginx = "nutellinoplayground/api-nginx"
                    Registry = "registry.hub.docker.com"
                    sh "git rev-parse --short HEAD > CommitSha"
                    CommitSha = readFile('CommitSha').trim()
                }

            }
        }
        stage('Download Vendor and copy src') {
            steps {
                script {

                    sh "ls -la"
                    sh "ls -la \$(pwd)"
                    sh "rm -rf vendor || true"
                    sh "rm -rf build/nginx/source || true"
                    sh "rm -rf build/php/source || true"
                    sh "mkdir build/nginx/source"
                    sh "mkdir build/php/source"
                    sh "cp index.php build/nginx/source/"
                    sh "cp index.php build/php/source/"
                    sh "cp composer.json build/php/source/"
                    sh "cp composer.lock build/php/source/"

                }
            }
        }


        stage('Build image Php') {
            steps {
                script {
                    app = docker.build(BaseimageNamePhp, "--pull build/php/")
                }
            }
        }

        stage('Push image Php') {
            steps {
                script {
                    docker.withRegistry("https://${Registry}", 'docker-hub-credentials') {
                        app.push("${tag}")
                        app.push("${CommitSha}")
                    }
                }
            }
        }


        stage('Build image Nginx') {
            steps {
                script {
                    app = docker.build(BaseimageNameNginx, "--pull build/nginx/")
                }
            }
        }

        stage('Push image Nginx') {
            steps {
                script {
                    docker.withRegistry("https://${Registry}", 'docker-hub-credentials') {
                        app.push("${tag}")
                        app.push("${CommitSha}")
                    }
                }
            }
        }
    }

}
